;Trying to make a Theremin thingy for the NES!
;---------------------------------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

FREQLO   EQU   #$00
FREQHI   EQU   #$01
DELAY    EQU   #$02
TEMPVAL1 EQU   #$03
TEMPVAL2 EQU   #$04

VIBRATO1 EQU   #$10
VIBRATO2 EQU   #$11
VIBRATODELAY EQU #$12

FREQHARDLO EQU #$20
FREQHARDHI EQU #$21


   ORG   $0200
;----------------------- Main_loop ---------------
   lda   #$C0
   sta   FREQHARDLO
   lda   #$00
   sta   FREQHARDHI

   lda   #$02
   sta   VIBRATODELAY
   lda   #$00
   sta   VIBRATO1

.Top200
   bit   $2002
   bpl   .Top200           ;Wait for VB to start...
.Top200_a
   bit   $2002
   bmi   .Top200_a         ;and end...

   jsr   GetTherFreq
   jsr   Vibrato

   lda   FREQLO
   sta   $4002
   lda   FREQHI
   sta   $4003

   lda   FREQLO
   clc
   adc   #$01
   sta   $4006
   lda   FREQHI
   adc   #$00
   sta   $4007

   jmp   .Top200


;-------------------------------------------------

Vibrato SUBROUTINE
;   dec   VIBRATODELAY
;   bne   .NoVibrato
   lda   #$02
   sta   VIBRATODELAY

   inc   VIBRATO1
   lda   VIBRATO1
   cmp   #$10
   bne   .NoResetVibrato
   lda   #$00
   sta   VIBRATO1


.NoResetVibrato
   ldx   VIBRATO1
   lda   .VIBRATOTBL,X

   clc
   adc   FREQHARDLO
   sta   FREQLO
   lda   FREQHARDHI
   sta   FREQHI

.NoVibrato
   rts

.VIBRATOTBL
   dc.b  #$00,#$03,#$06,#$09,#$0C,#$09,#$06,#$03
   dc.b  #$00,#$03,#$06,#$09,#$0C,#$09,#$06,#$03


GetTherFreq SUBROUTINE

   lda   #$00
   sta   FREQHARDLO
   sta   FREQHARDHI

   lda   #$00
   sta   $2006
   sta   $2006
   lda   $2007          ;Dummy read.

.ReadCHRBegin
   ldy   #$00

.ReadCHRCont
   lda   $2007
   sta   TEMPVAL1
   ldx   #$08

.ReadCHRCont2
   rol   TEMPVAL1       ;Puts into carry!

   lda   FREQHARDLO         ;Using the carry bit.
   adc   #$00
   sta   FREQHARDLO
   lda   FREQHARDHI
   adc   #$00
   sta   FREQHARDHI

   dex
   bne   .ReadCHRCont2  ;do the next bits.

   dey
   bne   .ReadCHRCont

   rts

;The end.
