;Trying to make a Theremin thingy for the NES!
;---------------------------------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

FREQLO   EQU   #$00
FREQHI   EQU   #$01
DELAY    EQU   #$02
TEMPVAL1 EQU   #$03
TEMPVAL2 EQU   #$04


   ORG   $E000

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$07    ;To clear 7 x $100 bytes, from $000 to $6FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0
;**************************************************************
   lda   #%10101010
   sta   FREQLO
   lda   #$00
   sta   FREQHI


   lda   #$07
   sta   $4015

   lda   #%10110111
   sta   $4000
   lda   #%01110111
   sta   $4004
   lda   #$00
   sta   $4001
   sta   $4005
   lda   FREQLO
   sta   $4002
   sta   $4006
   lda   FREQHI
   sta   $4003
   sta   $4007

;   lda   #%01110111
;   sta   $4004
;   lda   #$00
;   sta   $4005
;   lda   #%10101010
;   sta   $4006
;   lda   #$00
;   sta   $4007

;   lda   #%10000111
;   sta   $4008
;   lda   #$00
;   sta   $4009
;   lda   #%10110101
;   sta   $400A
;   lda   #$01
;   sta   $400B

;   lda   #%10110111
;   sta   $400C
;   lda   #$00
;   sta   $400D
;   lda   #%01110101
;   sta   $400E
;   lda   #%00000100
;   sta   $400F

;**************************************************************

   lda   #$20
   sta   $2006
   lda   #$00
   sta   $2006

   ldx   #$00
   ldy   #$10
.ClearPPU sta $2007
   dex
   bne   .ClearPPU
   dey
   bne   .ClearPPU

   lda   #$00
   sta   $2003
   tay
.ClearSpr sta   $2004
   dey
   bne   .ClearSpr

;********* Initialize Palette to specified colour ********

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$0D     ;Colour Value (Black)
   ldy   #$20     ;Clear BG & Sprite palettes.
.InitPal stx $2007
   dey
   bne   .InitPal
;*********************************************************

   lda   #$3F
   sta   $2006
   lda   #$01
   sta   $2006
   lda   #$00
   sta   $2007
   lda   #$10
   sta   $2007
   lda   #$20
   sta   $2007

;-----------------------------------------------------------
   lda   #$10
   sta   DELAY


;DISable vblank interrupts, etc.
;   lda   #%00000000
;   sta   $2000
;   lda   #%00011110        ;Screen on, sprites on, show leftmost 8 pixels, colour
;   sta   $2001
;  cli            ;Enable interrupts(?)

   ldx   #$00
.copyRAMloop
   lda   .delaystart,X
   sta   $0200,X
   inx
   bne   .copyRAMloop
   jmp   $0200

;***********************************************
;***********************************************
;***********************************************

.delaystart
   INCLUDE Theremin200.bin.asm

;***********************************************
;***********************************************
;***********************************************

;.loop jmp .loop


NMI_Routine SUBROUTINE
   rti

IRQ_Routine       ;Dummy label
   rti

;That's all the code. Now we just need to set the vector table approriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
